//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  LangBox->ItemIndex = 0;
  LfBox->ItemIndex = 0;
  AlreadyShown=false;
  IniFileName = ExtractFileDir(ParamStr(0)) + "\\qtlcpp.ini";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PasteButtonClick(TObject *Sender)
{
  Source->SelectAll();
  Source->PasteFromClipboard();
}//end TForm1::PasteButtonClick
//---------------------------------------------------------------------------

void __fastcall TForm1::CopyButtonClick(TObject *Sender)
{
  Destination->SelectAll();
  Destination->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GoButtonClick(TObject *Sender)
{
  char s[2];
  AnsiString buf, str, src, lf;
  int len, i, lfii;
  char *sPtr;
  char ch;
  s[1] = 0;
  src = Source->Text;
  len = src.Length();
  sPtr = src.c_str();
  lfii = LfBox->ItemIndex;
  buf = "\"";
  for (i=0; i<len; i++)
  {
    str = "";
    ch = sPtr[i];
    switch (ch)
    {
      case '\r':
        switch (lfii)
        {
          case 0:
            lf = "\\n";
          break;
          case 2:
            lf = "\\r";
          break;
          default:
            lf = "\\r\\n";
        }//end switch LfBox->ItemIndex
        str = lf + "\"+\r\n";
      break;
      case '\n':
        str = "\"";
      break;
      case '\"':
      case '\'':
      case '\\':
        s[0] = ch;
        str = (AnsiString)"\\" + s;
      break;
      default:
        s[0] = ch;
        str = s;
    }//end switch ch
    buf += str;
  }//end for i
  buf += "\";";
  Destination->Text = buf;
}//end TForm1::GoButtonClick
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  if (AlreadyShown) return;
  if (LoadIniFile())
  {
    SetLang();
    AlreadyShown=true;
  }
  else
    Application->MessageBox("ERROR!",
      "Cannot read ini file",
      MB_OK);
}//end TForm1::FormShow
//---------------------------------------------------------------------------


void TForm1::SetLang(void)
{
  switch (LangBox->ItemIndex)
  {
    case 0: //ru
      Label1->Caption = "Quick - C++";
      PasteButton->Caption = "  ";
      GoButton->Caption = "";
      Label3->Caption = " :";
      CopyButton->Caption = "     ";
      AboutBox->Caption = " ";
      AboutBox->Label4->Caption = ":";
      AboutBox->Label2->Caption = "      C++ ";
      AboutBox->Src->Caption = " ";
      AboutBox->Label3->Caption = ":  ";
      AboutBox->Label5->Caption = "  ";
      AboutBox->Button1->Caption =", !";
      AboutBox->Label6->Hint = "   ";
    break;
    case 2: //by
      Label1->Caption = "Quick - C++";
      PasteButton->Caption = "  ";
      GoButton->Caption = "";
      Label3->Caption = " :";
      CopyButton->Caption = "    ";
      AboutBox->Caption = " ";
      AboutBox->Label4->Caption = ":";
      AboutBox->Label2->Caption = "      C++ ";
      AboutBox->Src->Caption = " ";
      AboutBox->Label3->Caption = ": ̳ 븢";
      AboutBox->Label5->Caption = "  ";
      AboutBox->Button1->Caption =", !";
      AboutBox->Label6->Hint = "   ";
    break;
    case 3: //ua
      Label1->Caption = "Quick - C++";
      PasteButton->Caption = "  ";
      GoButton->Caption = "";
      Label3->Caption = " :";
      CopyButton->Caption = "     ";
      AboutBox->Caption = " ";
      AboutBox->Label4->Caption = ":";
      AboutBox->Label2->Caption = "      C++ ";
      AboutBox->Src->Caption = " ";
      AboutBox->Label3->Caption = ":  ";
      AboutBox->Label5->Caption = "  ";
      AboutBox->Button1->Caption =", !";
      AboutBox->Label6->Hint = "   ";
    break;
    case 4: //srb
      Label1->Caption = "Quick   C++";
      PasteButton->Caption = "  ";
      GoButton->Caption = "";
      Label3->Caption = " :";
      CopyButton->Caption = "     ";
      AboutBox->Caption = " ";
      AboutBox->Label4->Caption = ":";
      AboutBox->Label2->Caption = "      C++ ";
      AboutBox->Src->Caption = " ";
      AboutBox->Label3->Caption = ":  ";
      AboutBox->Label5->Caption = "  ";
      AboutBox->Button1->Caption =", !";
      AboutBox->Label6->Hint = " - ";
    break;
    case 5: //blg
      Label1->Caption = "Quick , , . C++";
      PasteButton->Caption = "  ";
      GoButton->Caption = "";
      Label3->Caption = ":";
      CopyButton->Caption = "      ";
      AboutBox->Caption = " ";
      AboutBox->Label4->Caption = ":";
      AboutBox->Label2->Caption = "       C++ ";
      AboutBox->Src->Caption = "";
      AboutBox->Label3->Caption = ":  ";
      AboutBox->Label5->Caption = "  ";
      AboutBox->Button1->Caption =", !";
      AboutBox->Label6->Hint = "    ";
    break;
    default:
      Label1->Caption = "Quick Tyap-Lyap C++";
      PasteButton->Caption = "Paste from clipboard";
      GoButton->Caption = "Convert";
      Label3->Caption = "Newlines:";
      CopyButton->Caption = "Select all and copy to clipboard";
      AboutBox->Caption = "About";
      AboutBox->Label4->Caption = "Version:";
      AboutBox->Label2->Caption = "program for converting multiline text to C++ code";
      AboutBox->Src->Caption = "source code";
      AboutBox->Label3->Caption = "The author: Mikhail Shmelev";
      AboutBox->Label5->Caption = "unformal personal site";
      AboutBox->Button1->Caption ="Yeah!";
      AboutBox->Label6->Hint = "show author\'s e-mail";
  }//end switch LangBox->ItemIndex
  AboutBox->Label1->Caption = Label1->Caption;
  Application->Title = Label1->Caption;
  Caption = Label1->Caption;
}//end TForm1::SetLang
//---------------------------------------------------------------------------

void __fastcall TForm1::LangBoxChange(TObject *Sender)
{
  SetLang();
  SaveIniFile();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AboutButtonClick(TObject *Sender)
{
  AboutBox->ShowModal();  
}
//---------------------------------------------------------------------------


bool TForm1::LoadIniFile(void)
{
TIniFile *IniFile;
bool ret=true;
try
{
  IniFile = new TIniFile(IniFileName);
  if (IniFile->SectionExists("General"))
  {
    if (IniFile->ValueExists("General", "Lang"))
      LangBox->ItemIndex = IniFile->ReadInteger("General", "Lang", 0);
  }
  /*    fflush on old systems    */
  IniFile->UpdateFile();
  delete IniFile;
}
catch (...)
{
  ret=false;
}
return ret;
}//end TForm1::LoadIniFile
//------------------------------------------------------

void TForm1::SaveIniFile(void)
{
  //TODO: Add your source code here
  TIniFile *IniFile;
  IniFile = new TIniFile(IniFileName);
  IniFile->WriteInteger("General", "Lang", LangBox->ItemIndex);
  /*    fflush on old systems    */
  IniFile->UpdateFile();
  delete IniFile;
}//end TForm1::SaveIniFile
//-----------------------------------------------------------
